%define python_sitelib	%(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%define debug_package	%{nil} 
%define version_source	20140806
%define rel		4

%if 0%{?fedora} || 0%{?centos} >= 7
%global         with_python3 1
%else
%global         with_python3 0
%endif


Name:		libewf
Version:	20160718
Release:	%{version_source}.%{rel}%{?dist}
Summary:	Library to support the Expert Witness Compression Format (EWF)
Group:		System Environment/Libraries
License:	LGPL
URL:		https://github.com/libyal/libewf/wiki
Source0:	%{name}-%{version_source}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:	zlib
BuildRequires:	zlib-devel
BuildRequires:  fuse-devel
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	gettext-devel
BuildRequires:	pkgconfig
BuildRequires:	flex
BuildRequires:	byacc
BuildRequires:	git
BuildRequires:	bzip2-devel
BuildRequires:	gcc-c++

%description
libewf is a library to support the Expert Witness Compression Format (EWF).
libewf allows you to read media information of EWF files in the SMART (EWF-S01)
format and the EnCase (EWF-E01) format. libewf allows to read files created by
EnCase 1 to 6, linen and FTK Imager.

%package	devel
Summary:	Header files and libraries for developing applications for libewf
Group:		Development/Libraries
Requires:	%{name} = %{version}

%description	devel
Header		files and libraries for developing applications for libewf.

%package	tools
Summary:	Several tools for reading and writing EWF files
Group:		Applications/System
Requires:	%{name} = %{version}
Requires:	openssl
BuildRequires:	flex byacc openssl-devel 
Requires:	libuuid
BuildRequires:	libuuid-devel 
Provides:	ewftools = %{version}
Obsoletes:	ewftools < %{version}

%description	tools
Several tools for reading and writing EWF files.
It contains tools to acquire, export, query and verify EWF files.

%package python2
Summary: Python bindings for libewf
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release} python
BuildRequires: python2-devel
Obsoletes: %{name}-python
Provides: %{name}-python = %{version}

%description python2
Python bindings for libewf

%if 0%{?with_python3}
%package python%{python3_pkgversion}
Summary: Python 3 bindings for libewf
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}
BuildRequires: python%{python3_pkgversion}
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-setuptools

%description python%{python3_pkgversion}
Python 3 bindings for libewf
%endif

%prep
%setup -q -n libewf-%{version_source}

%build
if [ -f synclibs.sh ]; then sh synclibs.sh; fi
if [ -f autogen.sh  ]; then sh autogen.sh;  fi
%if 0%{?centos} == 6
%configure --prefix=/usr --libdir=%{_libdir} --mandir=%{_mandir} --without-libbfio --enable-python --enable-v1-api --with-bzip2 \
%if "%{version_source}" <= "20140608"
  CFLAGS="${RPM_OPT_FLAGS} -std=gnu89"
%endif
%else
%configure --prefix=/usr --libdir=%{_libdir} --mandir=%{_mandir} --without-libbfio --enable-python2 --enable-python3 --enable-v1-api --with-bzip2 \
%if "%{version_source}" <= "20140608"
  CFLAGS="${RPM_OPT_FLAGS} -std=gnu89"
%endif
%endif

%install
rm -rf ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install

################################################################
# End of renames
################################################################

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS COPYING NEWS README
%attr(755,root,root) %{_libdir}/*.so.*

%files devel
%defattr(644,root,root,755)
%doc AUTHORS COPYING NEWS README ChangeLog
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig/libewf.pc
%{_includedir}/*
%{_mandir}/man3/*

%files tools
%defattr(644,root,root,755)
%doc AUTHORS COPYING NEWS README
%attr(755,root,root) %{_bindir}/ewf*
%{_mandir}/man1/*

%files python2
%defattr(644,root,root,755)
%if 0%{?centos} != 6
%license COPYING
%endif
%doc AUTHORS README
%{_libdir}/python2*/site-packages/*.a
%{_libdir}/python2*/site-packages/*.la
%{_libdir}/python2*/site-packages/*.so

%if 0%{?with_python3}
%files python%{python3_pkgversion}
%defattr(644,root,root,755)
%if 0%{?centos} != 6
%license COPYING
%endif
%doc AUTHORS README
%{_libdir}/python3*/site-packages/*.a
%{_libdir}/python3*/site-packages/*.la
%{_libdir}/python3*/site-packages/*.so
%endif

### Exclude expirimental files ###
%exclude %{_bindir}/ewfdebug

%changelog
* Thu Aug 29 2019 Lawrence R. Rogers <lrr@cert.org> 20160718-20140806-4
* Release 20160718-20140806-4
	Libewf-tools now obsoletes ewftools

* Sat May 18 2019 Lawrence R. Rogers <lrr@cert.org> 20160718-20140806-3
* Release 20160718-20140806-3
	Version 20160718-20140806-3: Uses python3_pkgversion for the current version of Python 3.

* Tue Apr  9 2019 Lawrence R. Rogers <lrr@cert.org> 20160718-20140806-2
* Release 20160718-20140806-2
        Release 2 - Rebuilt for Python 3.6 for CentOS/RHEL 7

* Tue Jan 29 2019 Lawrence R. Rogers <lrr@cert.org> 20160718-20140806-1
* Release 20160718-20140806-1
	This version is based on the source code of 20140806 but is numbered so that 
	it becomes the default version. The base-on-source is part of the release number.
	-python packages renamed to -python2

* Mon Jul 18 2016 Lawrence R. Rogers <lrr@cert.org> 20160718-1
* Release 20160718-1
	This version is based on the source code of 20140608 but is numbered so that 
	it becomes the default version. The base-on-source is part of the release number.

* Thu Jun 23 2016 Lawrence R. Rogers <lrr@cert.org> 20160623-1
* Release 220160623-1
	This version is based on the source code of 20140608 but is numbered so that 
	it becomes the default version.

* Thu Apr 21 2016 Lawrence R. Rogers <lrr@cert.org> 20160421-1
* Release 20160421-1
	20160411
	* worked on tests

	20160410
	* worked on version 2 format support
	* worked on new read/write chunk API

	20160409
	* worked on multi threading support in ewfacquirestream
	* worked on tests

	20160404
	* disabled bzip2 support for now
	* add check to see if target file can be written in ewfacquire,
	  ewfacquirestream, ewfexport, ewfrecover
	* created a queue of storage media buffers
	  - this blocks the reader thread if the queue is empty
	  - this limits the maximum size of output list

	20160403
	* worked on deployment

	20160402
	* worked on multi threading support in ewfacquirestream
	* fixes for Python-bindings tests
	* fixes for ewfexport writing notification messsages to stdout
	* changes for deployment
	* increased granularity of process status

	20160401
	* worked on tests
	* worked on thread locking support
	* worked on multi threading support in ewfverify and ewfacquire

	20160331
	* worked on tests
	* worked on thread locking support

	20160330
	* worked on thread locking support

* Thu Mar 31 2016 Lawrence R. Rogers <lrr@cert.org> 20160331-1
* Release 20160331-1
	20160329
	* worked on thread locking support

	20160328
	* worked on tests
	* worked on thread locking support

	20160326
	* changes for segment files read issue
	* implement table2 fallback support in libewf_chunk_group_fill_v1

	20160325
	* fixed leaks libewf_chunk_table_get_chunk_data_by_offset
	* worked on v2 support

	20160320
	* worked on tests
	* fix for printing sha256 in ewfexport

	20160319
	* worked on tests
	* fix for deployment using synclibs.sh
	* removed v1 API
	* removed delta file support
	  - outside the concern of this library
	* removed "random" functions from:
	  - libewf
	  - ewf.net
	  - pyewf

	20160318
	* applied updates
	* worked on tests

* Tue Feb  9 2016 Lawrence R. Rogers <lrr@cert.org> 20160209-1
* Release 20160209-1
	20160124
	* worked on refactor

	20160119
	* worked on combined Python 2 and 3 build support

	20160110
	* 2016 update

* Mon Jan  5 2015 Lawrence R. Rogers <lrr@cert.org> 20150105-2
* Release 20150105-2
	20150126
	* fix in ewf.net

	20150107
	* 2015 update

	20141229
	* updated dpkg files
	* updated dependencies
	* updated .gitignore

	20141226
	* changes for updated dependencies

	20141225
	* worked on Python 3 support

	20141210
	* fix in spec file for zlib-static

	20141204
	* small changes in progress status output
	* moved chunk groups cache into handle
	* moved libewf_chunk_table_chunk_exists_for_offset out of write-only code path

	20141201
	* code clean up
	* removed unrestrict_offset_table, added maximum of 128 M to size of offset table
	* removed ewf_definitions.h

* Mon Dec  8 2014 Lawrence R. Rogers <lrr@cert.org> 20141129-2
* Release 20141129-2
	This version is now built with version 1 compatibility which removes the need for libewf 20100226, aka libewf version 1.

* Sat Nov 29 2014 Lawrence R. Rogers <lrr@cert.org> 20141129-1
	20141129
	* code clean up

	20141102
	* bug fixes
	* ewf.net added FileEntry::GetType

	20141030
	* bug fix in Python-bindings
	* changes for updated dependencies

	20141021
	* changes for deployment

	20141012
	* bug fixes

	20141007
	* updated dependencies and corresponding changes
	* worked on autogen.sh and synclibs.sh scripts

	20141002
	* removed README.macosx
	* changes for project site move

	20140801
	* bug fix in Python-bindings

* Fri Jun 27 2014 Lawrence R. Rogers <lrr@cert.org> 20140608-2
	Added libewf-python

* Sun Jun 08 2014 Lawrence R. Rogers <lrr@cert.org> 20140608-1
	Joachim's 20140608 release, which includes:
	20140608
	* bug fix for utf16 header functions

	20140602
	* bug fix in ewfmount regarding logical files date and time values

	20140525
	* updated python.m4

	20140427
	* fixes to build static library with mingw and cygwin

	20140406
	* bug fixes in m4 files

	20140228
	* removed #error restriction in dependency include header files
	* make pyewf_handle_open more strict to catch non-string objects
	  without the check the code will segfault on non-string objects

* Sun Apr 27 2014 Lawrence R. Rogers <lrr@cert.org> 20140427-1
* Release 20140427-1
	Joachim's 20140427 release, which includes:

	* fixes to build static library with mingw and cygwin
	* bug fixes in m4 files
	* removed #error restriction in dependency include header files
	* make pyewf_handle_open more strict to catch non-string objects
	  without the check the code will segfault on non-string objects
	* bug fixes in empty block compression
	* bug fix in libewf_read_io_handle_read_chunk_data error tolerance
	  code path

* Mon Feb 24 2014 Lawrence R. Rogers <lrr@cert.org> 20140216-1
* Release 20140216-1
	Joachim's 20140216 release, which includes:

	* bug fix in recent process status changes
	* integrating latest update for multi threaded ewfacquire changes
	* changed behavior of empty-block check
	* worked on integrating multi threaded ewfacquire changes
	* updated dependencies
	* added libcdatetime
	* removed borlandc files
	* small updates
	* moved low-level function support from compile time to run time
	* worked on sync with experimental version

	* Also added missing fuse-devel build requirement
	
* Tue Dec 10 2013 Lawrence R. Rogers <lrr@cert.org> 20131210-1
* Release 20131210-1
	Joachim's 20131210 release, which includes:
	
	* updated dependencies
	* worked on Python bindings
	* added libcthreads
	* fix in DFXML output for size values
	* worked on ewfmount

* Thu Jun 6 2013 Lawrence R. Rogers <lrr@cert.org> 20130416-1
* Release 20130416-1
	Due to libbfio{,-devel} conflicts, the --without-libbfio was added to
	  the configure step to force use of a local (internal) copy of libbfio.

	Joachim's 20130416 release, which includes:

	20130416
	 * bug fix in libcfile.m4 for building on MingW and Cygwin
	 * fix in libsmdev for MinGW build

	20130402
	 * changes to zlib.m4 for adler32 detection
	 * moved README.mingw and README.static to wiki

	20130331
	 * worked on libcdata integration
	 * updated msvscpp files
	 * updated codegear files
	 * sync with experimental version

	20130330
	 * updated dependencies
	 * updates for libsmdev
	 * added error tolerance for Logicube image with missing checksum in data section
	 * code clean up
	 * worked on libcdata integration

	20130302
	 * updated types.h
	 * fixed maximum number of segments

	20130205
	 * changes and fixes in debug output

* Mon Jan 28 2013 Lawrence R. Rogers <lrr@cert.org> 20130128-1
* Release 20130128-1
	Joachim's 20130128 release 

* Sun Dec 9 2012 Lawrence R. Rogers <lrr@cert.org> 20120813-1
* Release 20121209-1
	Joachim's 20121209 release 

* Mon Aug 13 2012 Lawrence R. Rogers <lrr@cert.org> 20120813-1
* Release 20120813-1
	Joachim's 20120813 release 

* Sun Jun 3 2012 Lawrence R. Rogers <lrr@cert.org> 20120603-1
* Release 20120603-1
	Joachim's 20120603 release 

* Sat May 5 2012 Lawrence R. Rogers <lrr@cert.org> 20120504-1
* Release 20120504-1
	Joachim's 20120504 release 

* Mon Apr 16 2012 Lawrence R. Rogers <lrr@cert.org> 20120416-1
* Release 20120416-1
	Joachim's 20120416 release 

* Sun Feb 12 2012 Lawrence R. Rogers <lrr@cert.org> 20120212-1
* Release 20120212-1
	Joachim's 20120212 release 

* Fri Jan 27 2012 Lawrence R. Rogers <lrr@cert.org> 20120122-1
* Release 20120122-1
	Joachim's 20120122 release 

* Sat Dec 31 2011 Lawrence R. Rogers <lrr@cert.org> 20111231-1
* Release 20111231-1
	Joachim's 20111231 release 

* Wed Oct 26 2011 Lawrence R. Rogers <lrr@cert.org> 20111023-1
* Release 20111023-1
	Joachim's 20101023 release 

* Mon Oct 17 2011 Lawrence R. Rogers <lrr@cert.org> 20111016-1
* Release 20111016-1
	Joachim's 20101016 release 

* Mon Oct 10 2011 Lawrence R. Rogers <lrr@cert.org> 20111010-1
* Release 20111010-1
	Joachim's 20101010 release plus libewf.so.1.0.? from FC[12-15] and EL[5-6]

* Mon Aug  1 2011 Joachim Metz <jbmetz@users.sourceforge.net> 20110801-1
- Added libhmac and libfvalue, changed libcrypto build dependencies

* Fri Nov 19 2010 Joachim Metz <jbmetz@users.sourceforge.net> 20101119-1
- Added flex and byacc build dependencies

* Thu Nov  4 2010 Joachim Metz <jbmetz@users.sourceforge.net> 20101104-1
- Added README.static

* Wed Jul 14 2010 Joachim Metz <jbmetz@users.sourceforge.net> 20100714-1
- Clean up of previous version of spec file

